
  		;start of general purpose registers

      R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
 count	EQU 0x20		;used in delay routine
		count1	EQU  0x21		;used in delay routine
		counta	EQU  0x22		;used in delay routine
		countb	EQU  0x23		;used in delay routine
		temp	 EQU	0x44	;temp storage
	        temp1  EQU  0x45
                tempold EQU 0x2b
		zero EQU 0x46
                 A   EQU  0x47
                 A1 EQU 0x48
               val1 EQU 0x49
               val2 equ 0x4a
               val3 equ 0x4b
               val4 equ 0x4c
                temp2  equ 0x4d
                 temp3 equ 0x4e
                  temp4 equ 0x4f
               int_er equ 0x3a
                A2 EQU 0x43
;pins 1 and 2 are the 2 PWM channels
             
             zer EQU 0x37
            oldzero EQU 0x38
            older equ 0x30
      
             val equ 0x2d
              er equ 0x2e
            width equ 0x2f
          W_TEMP EQU 0x7F
	STATUS_TEMP EQU 0x7E

        
    	ORG	0x0000
    	
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO START
	ORG 0x0004
	MOVWF W_TEMP
	SWAPF STATUS,W
	CLRF STATUS
	MOVWF STATUS_TEMP
	CALL L0006
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	RETFIE

    	ORG	0x0040
START	
; 4: INTCON.INTE = 0  ;DISABLE EXT.INT
	BSF STATUS,RP0

           bsf 0x0c,1
            BsF STATUS,RP0

         nop
          bsf PIE1,tmr2ie   ; PIE1,TRMR2IE 
         
       
; 12: Enable
	BSF INTCON,GIE
           bsf intcon,6
          goto beg
; 18: On Interrupt 'interrupt routine
L0006:
; 19: If pir1.tmr2iF= 1 Then Goto q Else Goto tt ;it is ext int, from pulse
	;BTFSS 0x0B,2 ;
          btfss 0x0c,1
	GOTO L0008
	GOTO L00021
	
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
	GOTO L0004
; 20: q: it is timer overflow, count how many times it does
L00021:
; 21: a = a + 1
	;MOVF 0x2C,W
	;ADDLW 0x01
	;MOVWF 0x2C
          call apply1
       ;  bsf intcon, gie 
	
	
;
L0004: 	MOVLW 0x1F
	ANDWF STATUS,F
     ;   BsF PIR1, TMR2IF 
            bcf pie1,tmr2ie
	RETURN





 
BEG:
         clrf zero
    	;GOTO	START
    	;ORG	0x0010
	call Init
     ;  movlw  48
START1
 	CALL	Initialise
L0003:
; 1: Symbol ad_action = ADCON0.GO_DONE 'set new name for A/D conversion start bit
;       The address of 'ad_action' is 0x1F,2
; 2: Symbol display = PORTB 'set new name for PORTB used to display the conversion result
;       The address of 'display' is 0x6

; 4: TRISB = %00000000 'set PORTB pins as outputs
	BSF STATUS,RP0
	CLRF 0x06
        movlw 0xf8
        movwf 0x08  
 ;also port D as outputs
; 5: TRISA = %111111 'set PORTA pins as inputs
	MOVLW 0x3F
	MOVWF 0x05
; 6: ADCON0 = 0xc0 'set A/D conversion clock to internal source
	BCF STATUS,RP0
	MOVLW 0xc0
	MOVWF 0x1F
; 7: ADCON1 = 0 'set PORTA pins as analog inputs
	BSF STATUS,RP0
	CLRF 0x1F
; 8: High ADCON0.ADON 'turn on A/D converter module
	BCF STATUS,RP0
	BSF 0x1F,0
; 9:
; 10: main:
L0001:
         movlw 0x03
         movwf A
        movlw 0x0f
         movwf width
Loop
      
  movlw 0xc8 ;AD channel 2
         movwf 0x1F
         BCF STATUS,RP0
	BSF 0x1F,0
           
	CALL ADVAL
        ; 12: display = ADRESH 'display the result of the conversion
	MOVF 0x1E,W
          MOVWF temp
           btfsc portD,3  ;if port D bit 3 is high  display In Volts
           call decimal

   
      
            MOVLW 0xc0      ;select AD channel 1
     MOVWF 0x1F

		BCF STATUS,RP0
         bsf 0x1F,0
   
      
      call ADVAL      ;Read AD value for output volts
      
          movf 0x1e,w
     btfss portD,3  ; if switch D.3 is low
     call decimal1 ;display output volts
       
     ; call WAIT_t2  ;wait for T2 overflow

    call display  ;THIS LINE CAN BE OMITTED BY PUTTING A ";" IF  LED DISPLAY NOT USED
   call zerocrossing
        btfsc status,c
    goto loop
;width=error
     movfw 0x1e  ;volts read from output
   movwf width
     movwf val
     goto  loop
zerocrossing:
        movfw zer
        movwf oldzero ;if it is 0 -ff then carry 
;the following 8 instructions are for finding the start
; of the sine wave so as to up date only at every full
;sine wave
  
;remove line abov for actual working then only the update
; will happen once per cycle andnot always
   btfsc portd,7 ;Port D.7 sine-squared input for refernce is input
   goto loop3 ;keep it as ff if bit is high
   movlw 0   ; 0 if low
   movwf zer    
xx 

       movfw oldzero
       subwf zer,0
      
        return
loop3
          movlw 0xff
          movwf  zer
         goto xx


apply:
    ;  call display
     MOVFW WIDTH
     movwf temp
         goto loop
; 14: If temp > 128 Then Goto p1 else p2
apply1               ; called by ISR Timer2
	MOVFW WIDTH
     movwf temp
           MOVF temp,W
	SUBLW 0x80
	BTFSC STATUS,C
	GOTO L00041
	GOTO L0007
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 15: p1: Goto push1
L0002:

; 18: tempold = temp - 128
	MOVF temp,W
	SUBLW 0x80
x:	MOVWF tempold
	COMF tempold,1
;this complement instuction is part of the
; subtraction process of temp-0x80.
          
; 20: PORTC.0 = 0 ;portc bit 0 indicator shows wh. winding is energised rt or lft
	BCF 0x07,0
; 21: Goto main
	GOTO L00012
; 22: p2:
L00041:
; 23: tempold = 128 - temp
	MOVLW 0x80
	SUBWF temp,W  ;f-w
        BTFSC STATUS,Z
        goto L13
        
	MOVWF tempold
        
     COMF tempold,1

; 24: PORTC.0 = 1
	BSF 0x07,0
; 25: Goto main
;        update once per cycle!
           
L00011  
               
        movfw tempold          
     ;    MOVWF TEMP
  btfsc portd,7
    goto pushpull1
     	CALL	pulseL	;
     return
pushpull1:    CALL	pulseR
        RETURN

L00012
      movfw tempold
     ;    MOVWF TEMP
     btfsc portd,7
    goto pushpull11
   CALL	pulseR	;
     return
pushpull11:    CALL	pulseL
   RETURN
	     ; GOTO Loop
L13:  movlw  0
     ;  call decimal1

      movwf tempold
     	;MOVWF 0x2C
     ; COMF 0x2C,1
              goto L00011
pulseL:				;use value in W to set pulse (0-127)
    	MOVWF	tempold
	BTFSC	tempold, 7		;if more than 128 set pulse in reverse

	ANDLW	0x7F
    	MOVWF   CCPR1L
      Clrf CCPR2L
	RETURN

pulseR:
    	MOVWF	tempold
	BTFSC	tempold, 7
		ANDLW	0x7f
    	MOVWF   CCPR2L
   clrf CCPR1L
	RETURN



getpwm:
      ;pwm width continusally increases every T2 time, not used in this progrm
      movfw temp1
;      call sine
      ; movfw temp
       return
Init
        CLRF T2CON ; Stop Timer2, Prescaler = 1:1,
; Postscaler = 1:1
       CLRF TMR2 ; Clear Timer2 register
        
      bsf INTCON,GIE
;       enablee interrupts
      bsf intcon,PEIE
          ; enable PEIE
       bsf pir1,tmr2if
            bsf pie1,tmr2ie
     ;   CLRF PIR1 ; Clear peripheral interrupts Flags
        MOVLW 0x72 ; Postscaler = 1:15, Prescaler = 1:16
        MOVWF T2CON ; Timer2 is off
;        BSF T2CON, TMR2ON ; Timer2 starts to increment
        RETURN
;
display:
 ;return 
      clrf portD 
          comf portD,1
         decfsz A,1
                  goto D4
          goto D11
D4:       decfsz A,1
            
           goto D3
          goto D2
D11:        movfw 0x3d
         movwf 0x3c
          call getsegdata
         movwf count
         comf count,0
        movwf portB
         bcf portd,2
          movlw 3
          movwf A
          return
D2:        movfw 0x3e
       movwf 0x3c
          call getsegdata
    movwf count
         comf count,0

            movwf portB
        bcf portd,1
        incf A,1
         return

D3:        movfw 0x3F
         movwf 0x3c
          call getsegdata
     movwf count
         comf count,0


        movwf portB
         bcf portd,0
            incf A,1
         return
    ;goto WAIT_t2
  org 0x200
getsegdata:        ;  	mask = LookUp(0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 0x7f, 0x6f), digit

	SUBLW 0x09
	BTFSS STATUS,C
	GOTO L0012
	CALL L0013
	MOVWF 0x3c  ;data in 30
	GOTO L0012
L0013:
	MOVLW 0x02
	MOVWF PCLATH
	MOVF 0x3c,W
	ADDWF PCL,F
	RETLW 0x3F
	RETLW 0x06
	RETLW 0x5B
	RETLW 0x4F
	RETLW 0x66
	RETLW 0x6D
	RETLW 0x7D
	RETLW 0x07
	RETLW 0x7F
	RETLW 0x6F
L0012:
; 57: Return
	RETURN


         
	

       
Initialise:


    	BANKSEL  TRISC
    	MOVLW    0		;set PORTC as all outputs
    	MOVWF    TRISC
    	BANKSEL  PORTC
	   	MOVF     CCP1CON,W	;set CCP1 as PWM
    	ANDLW    0xF0
    	IORLW    0x0C
    	MOVWF    CCP1CON

    	MOVF     CCP2CON,W	;set CCP2 as PWM
    	ANDLW    0xF0
    	IORLW    0x0C
    	MOVWF    CCP2CON

    	MOVLW    245		;set highest PWM value
    	BANKSEL  PR2		;over this (127) is permanently on
    	MOVWF    PR2
    	BANKSEL  TMR2

    	MOVF     T2CON,W	;set prescaler to 1
    	ANDLW    0xF8		;PWM at 2500HZ
    	IORLW    0x01
    	MOVWF    T2CON

    	MOVFW     T2CON	;set postscaler to 1
    	ANDLW    0x07
    	IORLW    0x00
    	MOVWF    T2CON

    	CLRF	CCPR1L		;set PWM to zero
    	CLRF	CCPR2L

    	BSF      T2CON, TMR2ON	;and start the timer running
	RETURN

;




Delay1		movlw	0x01		;delay .200 ms (4 MHz clock)
d0		movwf	count1
d1		movlw	0xE7
		movwf	counta
		movlw	0x01
		movwf	countb
Delay_0		decfsz	counta, f
		goto	$+2
		decfsz	countb, f
		goto	Delay_0

		decfsz	count1	,f
		goto	d1
		return

; On exit,  result is in temp
ADVAL:
; 17: High ad_action 'start the conversion
	BSF 0x1F,2
; 18: While ad_action 'wait until conversion is completed
L00051:
	BTFSS 0x1F,2
	GOTO L00061
; 19: Wend
	GOTO L00051
L00061:	
         MOVLW 0x1F
	ANDWF STATUS,F
; 20: Return
	RETURN

decimal1:   movwf A1
 bcf status,c

            RRF A1,1
             bcf status,c
            RRF A1,0
               bcf status,c

            ADDLW 176
            bcf status,c
            
            RRF A1,1
            bcf status,c
            RRF A1,1
     bcf status,c

            RRF A1,1
           bcf status,c
           
           ADDWF A1,0
           ;  bcf status,c 
        ; return
decimal: ;/10 what is in W
        MOVWF R0L
	CLRF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
        MOVWF 0x3c  ; high digit intermed value
; i mod 10
        MOVF R2L,W
	MOVWF 0x3F     ;low digit
        MOVF 0x3c,W
         MOVWF R0L
	CLRF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
         MOVwf 0x3D ; highdigit
          MOVF R2L,W
	MOVWF 0x3E      ;next low digit
         return
; Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	MOVF R0L,W
	RETURN
end